# -*- encoding: utf-8 -*-
import numpy as np
import scipy.linalg

import matplotlib.pyplot as plt

domain = [-5, 5]
x = np.linspace(domain[0], domain[1], 100)

def runge(x):
	return 1.0 / (1.0 + x*x)
def build_system(degree, n_samples):
	# Diese Funktion generiert die Matrix A und die rechte Seite b der linearen Ausgleichung (2).
	exponent = np.arange(0, degree+1)
	x = np.linspace(domain[0], domain[1], n_samples)

	A = x[:,np.newaxis] ** exponent[np.newaxis,:]
	b = runge(x)
	return A, b

def solve(m):
	r""" Loesung der Aufgabe 1.b."""
	N = 15
	plt.figure(figsize=(12,8))
	cond_A = 2*np.ones(N-2)
	cond_AA = 2*np.ones(N-2)

	#############################################
	##                                         ##
	##          TODO: Aufgabe b)               ##
	##                                         ##
	#############################################


	plt.plot(x, runge(x), "k", linewidth=2, label=r"$\frac{1}{1+x^2}$")
	plt.title("standard Routinen aus Scipy mit " + str(m) + " Samples")
	plt.legend()
	plt.grid(True)
	plt.xlim(domain[0], domain[1])
	plt.savefig('runge_numpy' + str(m) +'.pdf')

	plt.show()

	plt.semilogy(np.arange(2,15),cond_A,label = r"$cond(A)$")
	plt.semilogy(np.arange(2,15),cond_AA,label = r"$cond(A^tA)$")
	plt.title("Konditionszahl mit " + str(m) + " Samples")
	plt.legend(loc = "best")
	plt.savefig('cond_' + str(m) +'.pdf')

	plt.show()

if __name__ == "__main__":

	m = 20

	solve(m)
