# -*- encoding: utf-8 -*-
import numpy as np
import numpy.linalg
import scipy
import scipy.linalg

np.set_printoptions(linewidth=200, formatter={'float': '{: 0.3f}'.format})

def power_method(A, n_rep = 100):
	r""" Power Method.
	INPUT: 
		A          :       Matrix
		n_rep      :       Number of repetitions for the power method
	OUTPUT: 
		eigenvalue :       Largest eigenvalue of A
	"""
	x = np.random.random(A.shape[0])
	x = x / np.linalg.norm(x)

	
	##############################################
	##                                          ##
	##              TODO: Implementiere         ##
	##       die direkte Potenzmethode          ##
	##											##
	##############################################

	eigenvalue = 0

	return eigenvalue
def ex_a(A):
	rho = power_method(A,100)
	print("The biggest eigenvalue of A is : " + str(rho))
def inverse_power_method(A, n_rep = 100):
	r""" Inverse Power Method, with LU-P decomposition.
	INPUT: 
		A          :       Matrix
		n_rep      :       Number of repetitions for the power method
	OUTPUT: 
		eigenvalue :       smallest eigenvalue of A
	"""

	P, L, U = scipy.linalg.lu(A)

	x = np.random.random(A.shape[0])
	x = x / np.linalg.norm(x)

	for k in range(n_rep):
		x = np.dot(P.transpose(), x) # We preconditionate the known value to get nicer results.
	##############################################
	##                                          ##
	##              TODO: Implementiere         ##
	##     		die inverse Potenzmethode       ##
	##											##
	##############################################

	eigenvalue = 0
	return eigenvalue
def ex_b(A):
	rho = inverse_power_method(A,100)
	print("The smallest eigenvalue of A is : " + str(rho))
def shifted_inverse_power_method(A, alpha, n_rep = 100):
	r""" Inverse Power Method, with LU-P decomposition.
	INPUT: 
		A          :       Matrix
		alpha      :       Reference value
		n_rep      :       Number of repetitions for the power method
	OUTPUT: 
		eigenvalue :       closest eigenvalue of A to the reference value alpha
	"""
	B = A - alpha*np.eye(A.shape[0])

	P, L, U = scipy.linalg.lu(B)

	x = np.random.random(A.shape[0])
	x = x / np.linalg.norm(x)

	for k in range(n_rep):
		x = np.dot(P.transpose(), x) # We preconditionate the known value to get nicer results.
	##############################################
	##                                          ##
	##              TODO: Implementiere         ##
	##     die shifted inverse Potenzmethode    ##
	##											##
	##############################################

	eigenvalue = 0
	return eigenvalue
def ex_c(A,v):
	rho = shifted_inverse_power_method(A,v,100)
	print("The closest eigenvalue of A to " + str(v) + " is : " + str(rho))


ew = np.array([150.0, 1.0, 8.0, 0.02, 0.55, 9.94, 23.6, 41.0, 63.71, 90.0])
n = ew.size
Q, _ = np.linalg.qr(np.random.random((n, n)))
A = np.dot(Q.transpose(), np.dot(np.diag(ew), Q))

ew, ev = np.linalg.eig(A)
print("Condition number of A : " + str(np.linalg.cond(A)))
print("Eigenvalues of A : ")
print(ew)

ex_a(A)
ex_b(A)
ex_c(A,45)
