# -*- encoding: utf-8 -*-
import numpy as np
import matplotlib.pyplot as plt
from scipy.optimize import fsolve

#lam = -10
lam = -2100

t0 = 0
T = 2

LineType = ['o-','^-']

def mod_exp_Euler(f,y,t,dt):
	r""" Explicit modified Euler method.
	INPUT:
			f :			Right hand side of the ODE y' = f(t,y)
			y :			approximate solution at known time level t=t_n, i.e. y_n
			t :         known time level t=t_n
			dt: 		time step

	OUTPUT:
			y_ : 		Approximate solution at time level t=t_{n+1}
	"""
	##########################################
	##              TODO:                   ##
	##     Implement the modified explicit  ##
	##            Euler Method              ##
	##                                      ##
	##########################################
	
	y_ = 0
	return y_
def mod_imp_Euler(f,y,t,dt):
	r""" Implicit modified Euler method.
	INPUT:
			f :			Right hand side of the ODE y' = f(t,y)
			y :			approximate solution at known time level t=t_n, i.e. y_n
			t :         known time level t=t_n
			dt: 		time step

	OUTPUT:
			y_ : 		Approximate solution at time level t=t_{n+1}
	"""

	##########################################
	##              TODO:                   ##
	##     Implement the modified implicite  ##
	##            Euler Method              ##
	##                                      ##
	##########################################

	y_ = 0
	return y_
def compute_error(f,y0,N,ye,method):
	r""" Function to compute the error of the method.
	INPUT:
			f :			Right hand side of the ODE y' = f(t,y)
			y0:			Start point
			N :         Number of time steps
			ye: 		Exact solution of the ODE
			method: 	method used to compute the approximate solution.

	OUTPUT:
			err : 		Error of the method at the end point

	"""
	t, h = np.linspace(t0,T,N,endpoint = True, retstep=True)
	sol = ye(t)
	y = np.zeros_like(t)
	y[0] = y0

	for k in range(N-1):
		y[k+1] = method(f,y[k],t[k],h)

	err = abs(sol[-1] - y[-1])
	return err
def ex_d(f,y0,ye,methods,labels):
	r""" 
	INPUT: 
		f : 		right hand side of the ODE y' = f(t,y)
		y0:			Start point
		ye: 		Exact solution of the ODE
		methods: 	Methods array to compare
		labels: 	Desired labels for plot
	"""
	NN = 2**np.arange(3,15)

	for method, lab, Lin in zip(methods,labels,LineType):
		error = []
		for N in NN:
			##########################################
			##              TODO:                   ##
			##     Compute Error of the method      ##
			##                                      ##
			##########################################
			error += [ 0 ]
		plt.loglog(NN,error,Lin,label = lab)

	plt.loglog(NN, (T-t0)/NN**2,'-',label = r"$h^2$")
	plt.legend(loc = "best")

	plt.savefig("convergence.pdf")
	plt.show()

	print(NN)
def ex_e(f,y0,ye,methods,labels):
	r""" 
	INPUT: 
		f : 		right hand side of the ODE y' = f(t,y)
		y0:			Start point
		ye: 		Exact solution of the ODE
		methods: 	Methods array to compare
		labels: 	Desired labels for plot
	"""

	# TODO: Complete with the given number of time steps

	N = 0

	for method, lab, Lin in zip(methods, labels, LineType):
		t, h = np.linspace(t0,T,N,endpoint = True, retstep=True)
		y = np.zeros_like(t)
		y[0] = y0

		for k in range(N-1):
			#TODO: update solution
			y[k+1] = 0

		plt.plot(t,y,Lin,label = lab)

	plt.plot(t,ye(t),'-',label = "Exact")
	plt.legend(loc = "best")
	
	plt.savefig("stability.pdf")
	plt.show()


if __name__ == '__main__':

	#TODO: Complete with given initial datum y0, right hand side f and exaxt solution ye.
	y0 = 0
	f = lambda t, y: 0
	ye = lambda t: 0

	methods = [mod_exp_Euler, mod_imp_Euler]
	labels = ['mod. expl. Euler', 'mod. impl. Euler']

	#ex_d(f,y0,ye,methods,labels)
	#ex_e(f,y0,ye,methods,labels)


